﻿-- Author      : Linty


dungstat={frame=CreateFrame("Frame"), core={}, utils={}, event={},vars={},broker={}, icons={}, UI={}};




dungstat.frame:SetScript("OnEvent", function(self, event, ...)
 dungstat.event:handler(self,event, ...); -- call event handler
end);

dungstat.vars.debug=1; -- set debug level to critical only
dungstat.vars.tankWait=0;
dungstat.vars.healWait=0;
dungstat.vars.dpsWait=0;
dungstat.vars.avgWait=0;
dungstat.vars.myWait=0;

dungstats_options= {hideWindow=false, version=0.1};

dungstat.vars.html="";

---- Init UI Rows (Display Rows)
dungstat.UI.rowCount=5;
dungstat.UI.rowCurr=0;

---------------------------Refresh Set-up setup--------
dungstat.vars.updatetime=2; --- Update Every x aseconds.
dungstat.vars.starttime={}

dungstat.vars.starttime[LE_LFG_CATEGORY_LFD]=0
dungstat.vars.starttime[LE_LFG_CATEGORY_LFR]=0
dungstat.vars.starttime[LE_LFG_CATEGORY_RF]=0
dungstat.vars.starttime[LE_LFG_CATEGORY_SCENARIO]=0
dungstat.vars.starttime[LE_LFG_CATEGORY_FLEXRAID]=0

 --when did last search start?


---------------------------Register Events--------
-- dungstat.frame:RegisterEvent("VARIABLES_LOADED");
-- dungstat.frame:RegisterEvent("ADDON_LOADED");


-- dungstat.frame:RegisterEvent("LFG_PROPOSAL_UPDATE");
-- dungstat.frame:RegisterEvent("LFG_PROPOSAL_SHOW");
-- dungstat.frame:RegisterEvent("LFG_PROPOSAL_FAILED");
-- dungstat.frame:RegisterEvent("LFG_PROPOSAL_SUCCEEDED");
-- dungstat.frame:RegisterEvent("LFG_UPDATE");
-- dungstat.frame:RegisterEvent("PLAYER_ENTERING_WORLD");
-- dungstat.frame:RegisterEvent("LFG_ROLE_CHECK_SHOW");
-- dungstat.frame:RegisterEvent("LFG_ROLE_CHECK_HIDE");
-- dungstat.frame:RegisterEvent("LFG_BOOT_PROPOSAL_UPDATE");
-- dungstat.frame:RegisterEvent("LFG_ROLE_UPDATE");
-- dungstat.frame:RegisterEvent("LFG_UPDATE_RANDOM_INFO");
-- dungstat.frame:RegisterEvent("LFG_QUEUE_STATUS_UPDATE");

-- dungstat.frame:RegisterEvent("BATTLEFIELD_MGR_EJECTED");
-- dungstat.frame:RegisterEvent("BATTLEFIELD_MGR_ENTERED");
-- dungstat.frame:RegisterEvent("BATTLEFIELD_MGR_ENTRY_INVITE");
-- dungstat.frame:RegisterEvent("BATTLEFIELD_MGR_QUEUE_INVITE");
-- dungstat.frame:RegisterEvent("BATTLEFIELD_MGR_QUEUE_REQUEST_RESPONSE");
-- dungstat.frame:RegisterEvent("BATTLEFIELD_MGR_STATE_CHANGE");
-- dungstat.frame:RegisterEvent("BATTLEFIELD_QUEUE_TIMEOUT");
-- dungstat.frame:RegisterEvent("PVPQUEUE_ANYWHERE_UPDATE_AVAILABLE");
-- dungstat.frame:RegisterEvent("PVPQUEUE_ANYWHERE_SHOW");
-- dungstat.frame:RegisterEvent("UPDATE_BATTLEFIELD_STATUS");
-- dungstat.frame:RegisterEvent("NPC_PVPQUEUE_ANYWHERE");
-- dungstat.frame:RegisterEvent("PVPQUEUE_ANYWHERE_SHOW");

dungstat.frame:RegisterEvent("ADDON_LOADED");
dungstat.frame:RegisterEvent("VARIABLES_LOADED");


 ----------------- Register image Paths
--dungstat.icons.pet = 618972 -- "Interface/Icons/Icon_PetFamily_Beast"
--dungstat.icons.tank = 135874 --  "Interface/Icons/Spell_Holy_AvengersShield"
--dungstat.icons.dps = 135882 --"Interface/Icons/Spell_Holy_BlessingOfStrength"
--dungstat.icons.healz = 135921 -- "Interface/Icons/Spell_Holy_HolyGuidance"

dungstat.icons.pet = "Interface\\Icons\\Icon_PetFamily_Beast"
dungstat.icons.tank = "Interface\\Icons\\Spell_Holy_AvengersShield.blp"
dungstat.icons.dps = "Interface\\Icons\\Spell_Holy_BlessingOfStrength"
dungstat.icons.healz = "Interface\\Icons\\Spell_Holy_HolyGuidance"

dungstat.icons.pvp = dungstat.icons.dps
--dungstat.icons.time = "Interface/Icons/INV_Misc_PocketWatch_02"

-------------------------------------- Timer Start

C_Timer.After(2, function ()  dungstat:update() end)


------------------------UI Management -------------------------

function dungstat.UI:UpdateRow(yPos,img1,img1A,img2,img2A,img3,img3A,txt)
	
	dungstat.utils:Debug(3,"Update row:: ".. dungstat.utils:SafeNil(yPos))

	if (yPos~=nil and yPos>0 and yPos<=dungstat.UI.rowCount) then

		if (img1~=nil) then
			_G["DungStatusFrame_row_"..yPos.."_img1"]:SetAlpha(img1A);
			_G["DungStatusFrame_row_"..yPos.."_img1"]:SetTexture(img1);
			_G["DungStatusFrame_row_"..yPos.."_img1"]:Show();
		else
			_G["DungStatusFrame_row_"..yPos.."_img1"]:Hide();    
		end

		if (img2~=nil) then
			_G["DungStatusFrame_row_"..yPos.."_img2"]:SetTexture(img2);
			_G["DungStatusFrame_row_"..yPos.."_img2"]:SetAlpha(img2A);
			_G["DungStatusFrame_row_"..yPos.."_img2"]:Show();
		else
			_G["DungStatusFrame_row_"..yPos.."_img2"]:Hide();  	
		end

		if (img3~=nil) then
			_G["DungStatusFrame_row_"..yPos.."_img3"]:SetTexture(img3);
			_G["DungStatusFrame_row_"..yPos.."_img3"]:SetAlpha(img3A);
			_G["DungStatusFrame_row_"..yPos.."_img3"]:Show();
		else
			_G["DungStatusFrame_row_"..yPos.."_img3"]:Hide();  	
		end

		if (txt~=nil) then
			_G["DungStatusFrame_row_"..yPos.."_label"]:SetText(txt);
			_G["DungStatusFrame_row_"..yPos.."_label"]:Show();
		else
			_G["DungStatusFrame_row_"..yPos.."_label"]:Hide();  	
		end
	end

end

function dungstat.UI:HideRow(yPos)
	dungstat.utils:Debug(3,"Hide row:: "..yPos)

	dungstat.UI:UpdateRow(yPos,nil,nil,nil,nil,nil,nil,nil)

end

function dungstat.UI:HideAllRows()
	for n=1, dungstat.UI.rowCount do
		dungstat.UI:UpdateRow(n,nil,nil,nil,nil,nil,nil,nil)
	end
end

function dungstat.UI:Reset()
	dungstat.UI:HideAllRows()
	dungstat.UI.rowCurr=0;
end
------------------------Send Mesage to chat---------------------
function dungstat.utils:Chat(chatmsg)

	if (chatmsg==nil) then 
		chatmsg="";
	end
	
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFF000Dungeon Status: |r"..chatmsg);
end

------------------------Send Debug to chat---------------------
function dungstat.utils:Debug(level, debugStr) --- level == 0-Critical, 1- Important, 2-Information, 3-trace only
		
		if (debugStr==nil or level == nil) then 
			return;
		end
		if (dungstat.vars.debug+1<level) then 
				return;
		end
		
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFF000Dungeon Status: |cffff0000[Debug] |r"..debugStr);
end

---------------------------------Helper Functions---------------------------------
function dungstat.utils:SafeNil(StringVar)
		if (StringVar== nil) then
			return "";
		end

		return StringVar;
end 

function dungstat.utils:TimeString(secs)

	if (secs==nil) then
		return "-";
	end
	
	if (secs<60) then
		return "< 1m";
	end
		
	
	
	local mins=math.floor(secs/60);
	local hours=0;
	local days=0;

	hours,mins=math.modf(mins/60);
	mins=math.floor(mins*60);

	days,hours=math.modf(hours/24);

	hours=math.floor(hours*24);

	sret=""
	if (days>0) then
		sret=days.."d ";
	end

	if (hours>0 or days>0) then
		sret=sret..hours.."h ";
	end

	sret=sret..mins.."m ";

return sret;
end


--------------------------Event Handler---------------------------------
function dungstat.event:handler(self, event, ...)

	if (event=="ADDON_LOADED") then
         
        
        
    elseif (event=="VARIABLES_LOADED") then
			
           
           --dungstat_CreateConfig();
    end

end

function dungstat:update()

	DungStatDBTooltip_Clear();
	DungStatusFrame_text:SetText("");
	dungstat.vars.html="";

	dungstat.UI:Reset();

	 
	local cnt=0
	
	cnt=cnt+dungstat.utils:updateQueue(LE_LFG_CATEGORY_LFD);
	cnt=cnt+dungstat.utils:updateQueue(LE_LFG_CATEGORY_LFR);
	cnt=cnt+dungstat.utils:updateQueue(LE_LFG_CATEGORY_RF);
	cnt=cnt+dungstat.utils:updateQueue(LE_LFG_CATEGORY_SCENARIO);
	cnt=cnt+dungstat.utils:updateQueue(LE_LFG_CATEGORY_FLEXRAID);
	
	for n=1, MAX_WORLD_PVP_QUEUES do
	
		cnt=cnt+dungstat.utils:updatePVP(n)
	end
	
	for n=1, GetMaxBattlefieldID() do
	
		cnt=cnt+dungstat.utils:updateBF(n)
	end
	
	cnt=cnt+dungstat.utils:updatePet()
	
	
	
	--DungStatusFrame_text:SetHeight((cnt*18));
	DungStatusFrame_winback:SetHeight((cnt*18)+5);
    DungStatusFrame:SetHeight((cnt*18)+5);
	
	--Chronos.unscheduleByName("DungStatus_Update")
	if cnt==0 then
			
			DungStatDBTooltip_Reset()
			dungstat.utils:showWin(false)
	end	
	
	C_Timer.After(2, function ()  dungstat:update() end)
end

function dungstat.utils:updateBF(qId)
	

	local status, mapName, instanceID, bracketMin, bracketMax, teamSize, registeredMatch = GetBattlefieldStatus(qId)
	
	--dungstat.utils:Chat(qId.." :BF: "..status)
		if (status=="queued") then
			
			
			
			local timeInQueue = math.floor(GetBattlefieldTimeWaited(qId)/1000)
			local waitTime = math.floor(GetBattlefieldEstimatedWaitTime(qId)/1000)
			
						
			
			if (timeInQueue==0 or timeInQueue==nil) then
				timeInQueue=1
			end
			
			if (waitTime==nil) then
				waitTime=600
			end
			

			--	dungstat.utils:Chat(qId.." :BFm: "..status)
				
				DungStatDBTooltip_Add(0, 0, 0, 0, 0, 0 ,"pvp", mapName,false,dungstat.utils:TimeString(timeInQueue).." |cffFFFF00("..dungstat.utils:TimeString(waitTime).." wait)")
				dungstat.utils:Win_Add(0, 0, 0, 0, 0, 0 ,"pvp", mapName,false,dungstat.utils:TimeString(timeInQueue).." |cffFFFF00("..dungstat.utils:TimeString(waitTime).." wait)")
		

			 dungstat.utils:showWin(true)
			
			return 1;
		else
			
			return 0;
			
			
		
		end

	
end

function dungstat.utils:updatePVP(qId)
	

	local status, mapName, queueID = GetWorldPVPQueueStatus(qId)
	--dungstat.utils:Chat(qId.." :PVP: "..status)
		if (status=="queued") then
			
			if (dungstat.vars.starttime["pvp"..qId]==0 or dungstat.vars.starttime["pvp"..qId]==nil ) then 
	
				dungstat.vars.starttime["pvp"..qId]=time(); --- Start time
				
			end
			
			
			

			
			--local hasData, leaderNeeds, tankNeeds, healerNeeds, dpsNeeds, tankTotal, healerTotal, dpsTotal, instanceType, instanceSubType, instanceName, averageWait, tankWait, healerWait, damageWait, myWait = GetLFGQueueStats(qID);
						
			--if (not hasData) then
			--	return 0;
			--end
			

			
			
			
			
			
				if (dungstat.vars.starttime["pvp"..qId]==0) then return  end; --- LFG Not Active


				
				DungStatDBTooltip_Add(0, 0, 0, 0, 0, 0 ,"pvp", mapName,false,dungstat.utils:TimeString(time()-dungstat.vars.starttime["pvp"..qId]))
				dungstat.utils:Win_Add(0, 0, 0, 0, 0, 0 ,"pvp", mapName,false,dungstat.utils:TimeString(time()-dungstat.vars.starttime["pvp"..qId]))
		

			 dungstat.utils:showWin(true)
			
			return 1;
		else
			dungstat.vars.starttime["pvp"..qId]=0; -- Reset start Time
			return 0;
			
			
		
		end

	
end

function dungstat.utils:updatePet()
	
	local status, value, waittime= C_PetBattles.GetPVPMatchmakingInfo()
	
	
	myWait=math.floor(waittime/1000)
	
	local waiting = C_PetBattles.IsWaitingOnOpponent()
	--dungstat.utils:Chat(qId.." :PVP: "..status)
		if (status=="queued")  then
			
			if (dungstat.vars.starttime["pet"]==0 or dungstat.vars.starttime["pet"]==nil ) then 
	
				dungstat.vars.starttime["pet"]=time(); --- Start time
				
			end
			
			
			

			
			--local hasData, leaderNeeds, tankNeeds, healerNeeds, dpsNeeds, tankTotal, healerTotal, dpsTotal, instanceType, instanceSubType, instanceName, averageWait, tankWait, healerWait, damageWait, myWait = GetLFGQueueStats(qID);
						
			--if (not hasData) then
			--	return 0;
			--end
			

			
			
			
			
			
				if (dungstat.vars.starttime["pet"]==0) then return  end; --- LFG Not Active


				
				DungStatDBTooltip_Add(0, 0, 0, 0, 0, 0 ,"pet", "Pet Battle",false,dungstat.utils:TimeString(time()-dungstat.vars.starttime["pet"]).." |cffFFFF00("..dungstat.utils:TimeString(myWait).." wait)")
				dungstat.utils:Win_Add(0, 0, 0, 0, 0, 0 ,"pet", "Pet Battle",false,dungstat.utils:TimeString(time()-dungstat.vars.starttime["pet"]).." |cffFFFF00("..dungstat.utils:TimeString(myWait).." wait)")
		

			 dungstat.utils:showWin(true)
			
			return 1;
		else
			dungstat.vars.starttime["pet"]=0; -- Reset start Time
			return 0;
			
			
		
		end

	
end


function dungstat.utils:updateQueue(qID)

	local lfdmode, lfdsubmode=GetLFGMode(qID);

		if (lfdmode=="queued") then
			
			if (dungstat.vars.starttime[qID]==0) then 

				dungstat.vars.starttime[qID]=time(); --- Start time

			end
			

			local hasData, leaderNeeds, tankNeeds, healerNeeds, dpsNeeds, tankTotal, healerTotal, dpsTotal, instanceType, instanceSubType, instanceName, averageWait, tankWait, healerWait, damageWait, myWait = GetLFGQueueStats(qID);
						
			if (not hasData) then
				return 0;
			end
			

			
			------ Store Times for Tooltip
			dungstat.vars.tankWait=tankWait;
			dungstat.vars.healWait=healerWait;
			dungstat.vars.dpsWait=damageWait;
			dungstat.vars.avgWait=averageWait;
			dungstat.vars.myWait=myWait;
			
			
			
			
			if (myWait<0) then

				------ Update Tooltip
				if (dungstat.vars.starttime[qID]==0) then return  end; --- LFG Not Active


				
				DungStatDBTooltip_Add(tankNeeds, healerNeeds, dpsNeeds, tankTotal, healerTotal, dpsTotal ,qID, instanceName,leaderNeeds,
						dungstat.utils:TimeString(time()-dungstat.vars.starttime[qID]))
				dungstat.utils:Win_Add(tankNeeds, healerNeeds, dpsNeeds, tankTotal, healerTotal, dpsTotal ,qID, instanceName,leaderNeeds,
						dungstat.utils:TimeString(time()-dungstat.vars.starttime[qID]))
				
			else

				------ Update Tooltip
				
				DungStatDBTooltip_Add(tankNeeds, healerNeeds, dpsNeeds, tankTotal, healerTotal, dpsTotal ,qID, instanceName,leaderNeeds,
						dungstat.utils:TimeString(time()-dungstat.vars.starttime[qID]).." |cffFFFF00("..dungstat.utils:TimeString(myWait).." wait)")
				dungstat.utils:Win_Add(tankNeeds, healerNeeds, dpsNeeds, tankTotal, healerTotal, dpsTotal ,qID, instanceName,leaderNeeds,
						dungstat.utils:TimeString(time()-dungstat.vars.starttime[qID]).." |cffFFFF00("..dungstat.utils:TimeString(myWait).." wait)")
			end
			
		

				
			 dungstat.utils:showWin(true)
			
			return 1;
		else
			dungstat.vars.starttime[qID]=0; -- Reset start Time
			return 0;
			
			
		
		end

	
end

function  dungstat_show_set(show)
	if show then 
		dungstats_options.hideWindow=false
	else
		dungstats_options.hideWindow=true
		dungstat.utils:showWin(false)
	end
	

end

function dungstat.utils:showWin(show)
	if (dungstats_options.hideWindow==true or show==false) then
		if (DungStatusFrame.IsVisible) then DungStatusFrame:Hide(); end
	else
		DungStatusFrame:Show();
	end

end


function  dungstat.utils:HTMLIcon(path)
	return "|T"..path..":16|t"
end

function  dungstat.utils:Win_Add(tankNeeds, healerNeeds, dpsNeeds, tankTotal, healerTotal, dpsTotal, iType, instanceName,leaderNeeds, timestring)

	if (dungstat.UI.rowCurr>=dungstat.UI.rowCount) then -- no more space
		return
	end

	dungstat.UI.rowCurr=dungstat.UI.rowCurr+1;

--	html=""
	
	if (iType=="pvp") then -- 
		
		dungstat.UI:UpdateRow(dungstat.UI.rowCurr,nil,nil,nil,nil,dungstat.icons.pvp,1," |cff00FFFFPVP - |cff00ff00"..timestring);

--		html=html..dungstat.utils:HTMLIcon(dungstat.icons.pvp).." |cff00FFFFPVP  |TInterface\\Icons\\INV_Misc_PocketWatch_02.blp:16|t"
--		html=""..html.."|cff00ff00"..timestring
	elseif (iType=="pet") then -- 
		
		dungstat.UI:UpdateRow(dungstat.UI.rowCurr,nil,nil,nil,nil,dungstat.icons.pet,1," |cff00FFFFPet - |cff00ff00"..timestring);
--		html=html..dungstat.utils:HTMLIcon(dungstat.icons.pet).." |cff00FFFFPet |TInterface\\Icons\\INV_Misc_PocketWatch_02.blp:16|t"
--		html=""..html.."|cff00ff00"..timestring

	else
	
		local img1A=0.5;
		local img2A=0.5;
		local img3A=0.5;

		if (tankNeeds==0 and tankTotal>0) then  
			img1A=1;
--			html=html.."|TInterface\\Icons\\Achievement_PVP_G_09.blp:16|t"
--		else
--			html=html.."|TInterface\\Icons\\Achievement_PVP_H_09.blp:16|t"
		end


		if (dpsNeeds==0 and dpsTotal>0) then
			img2A=1;
--			html=html.."|TInterface\\Icons\\Achievement_PVP_G_06.blp:16|t"
--		else
--			html=html.."|TInterface\\Icons\\Achievement_PVP_H_06.blp:16|t"
		end 

		if (healerNeeds==0 and healerTotal>0) then
			img3A=1;
--			html=html.."|TInterface\\Icons\\Achievement_PVP_G_10.blp:16|t"
--		else
--			html=html.."|TInterface\\Icons\\Achievement_PVP_H_10.blp:16|t"
		end 
		
		local txt = "";

		if (iType==LE_LFG_CATEGORY_LFD) then -- Instance
			
--			html=html.." |cff00FFFFLFD "
			txt=" |cff00FFFFLFD "

		elseif (iType==LE_LFG_CATEGORY_LFR) then -- 
		
--			html=html.." |cff00FFFFLFR "
			txt=" |cff00FFFFLFR "

		elseif (iType==LE_LFG_CATEGORY_RF) then -- 
		
--			html=html.." |cff00FFFFRF "
			txt=" |cff00FFFFRF "
		
		elseif (iType==LE_LFG_CATEGORY_SCENARIO) then -- 
		
--			html=html.." |cff00FFFFScenario "
			txt=" |cff00FFFFScenario "
		
		elseif (iType==LE_LFG_CATEGORY_FLEXRAID) then -- 
		
--			html=html.." |cff00FFFFFR "
			txt=" |cff00FFFFFR "
		
		end
		
		TOTAL = (tankTotal+dpsTotal+healerTotal)
--		html=""..html..": |cffFFFF00"..(TOTAL-(tankNeeds+dpsNeeds+healerNeeds)).."|cffffffff/|cffFFFF00"..TOTAL.."  |TInterface\\Icons\\INV_Misc_PocketWatch_02.blp:16|t|cff00ff00"..timestring ..""
		txt=txt.."|cffFFFF00"..(TOTAL-(tankNeeds+dpsNeeds+healerNeeds)).."|cffffffff/|cffFFFF00"..TOTAL.."  - |cff00ff00"..timestring ..""
		
		dungstat.UI:UpdateRow(dungstat.UI.rowCurr,dungstat.icons.tank,img1A,dungstat.icons.dps,img2A,dungstat.icons.healz,img3A,txt);

	end

	
--	if dungstat.vars.html~="" then
--		dungstat.vars.html=dungstat.vars.html.."\n"
--	end
	
--	dungstat.vars.html=dungstat.vars.html..html
	--DungStatusFrame_html:SetText("<html><body>"..dungstat.vars.html.."</html></body>")
--	DungStatusFrame_text:SetText(dungstat.vars.html)
end
